﻿using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using VSMPrototypePattern.Models;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace VSMPrototypePattern
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        private readonly Person _sourcePerson;

        public MainPage()
        {
            this.InitializeComponent();
            _sourcePerson = new Person();
            _sourcePerson.Address = new Address();
            SourcePerson.DataContext = _sourcePerson;
            SourcePersonAddress.DataContext = _sourcePerson.Address;
        }

        private void ClonePerson_Click(object sender, RoutedEventArgs e)
        {
            var shallowClone = _sourcePerson.ShallowClone();
            ShallowClone.DataContext = shallowClone;
            ShallowPersonAddress.DataContext = shallowClone.Address;

            var deepClone = _sourcePerson.DeepClone();
            DeepClone.DataContext = deepClone;
            DeepPersonAddress.DataContext = deepClone.Address;
        }
    }
}
