﻿namespace VSMPrototypePattern.Models
{
    public class Address : BaseModel<Address>
    {
        private string _street;
        private string _stateOrProvince;
        private string _country;
        private string _postalCode;

        public string Street
        {
            get { return _street; }
            set { _street = value; NotifyPropertyChanged(); }
        }

        public string StateOrProvince
        {
            get { return _stateOrProvince; }
            set { _stateOrProvince = value; NotifyPropertyChanged(); }
        }

        public string Country
        {
            get { return _country; }
            set { _country = value; NotifyPropertyChanged(); }
        }

        public string PostalCode
        {
            get { return _postalCode; }
            set { _postalCode = value; NotifyPropertyChanged(); }
        }
    }
}
